## bedops 2.4.39+dfsg1

=== Makefile ===
export KERNEL         := ${shell uname -a | cut -f1 -d' '}
APPDIR                 = applications/bed
OTHERDIR               = applications/other
OSXPKGROOT             = packaging/os_x
OSXBUILDDIR            = ${OSXPKGROOT}/build
OSXPKGDIR              = ${OSXPKGROOT}/resources/bin
OSXLIBDIR              = ${OSXPKGROOT}/resources/lib
SELF                   = ${shell pwd}/Makefile
MASSIVE_REST_EXP       = 22
MASSIVE_ID_EXP         = 18
MASSIVE_CHROM_EXP      = 8
MEASURE128BIT          = 'long double'
JPARALLEL              = 8
MEGAROW                = megarow
TYPICAL                = typical
FLOAT128               = float128
ALL_BINARY_TYPES       = ${TYPICAL} ${MEGAROW} ${FLOAT128}
DEFAULT_BINARY_TYPE    = ${TYPICAL}
export BINARY_TYPE     = ${DEFAULT_BINARY_TYPE}
DEBUG_TYPE             = ${TYPICAL}
WRAPPERS               = $(wildcard ${APPDIR}/conversion/src/wrappers/*)
CWD                   := $(shell pwd)
BINDIR                 = bin
BINDIR_MODULE          = modules
export DESTBINDIR      = .

default:
ifeq ($(KERNEL), Darwin)
	$(MAKE) $(MAKECMDGOALS) -j $(JPARALLEL) -f system.mk/Makefile.darwin
else
	$(MAKE) $(MAKECMDGOALS) -j $(JPARALLEL) -f system.mk/Makefile.linux
endif

clean: default

support: default

debug: default

gprof: default

all:
	$(MAKE) support -f ${SELF}
	$(MAKE) typical -f ${SELF}
	$(MAKE) megarow -f ${SELF}
	$(MAKE) float128 -f ${SELF}
	$(MAKE) install_all -f ${SELF}
	$(MAKE) symlink_post_install_all -f ${SELF}

module_all:
	$(MAKE) support -f ${SELF}
	$(MAKE) typical -f ${SELF}
	$(MAKE) megarow -f ${SELF}
	$(MAKE) float128 -f ${SELF}
	$(MAKE) install_all -f ${SELF}
	$(MAKE) module_binaries -f ${SELF}

float128:
	$(MAKE) BINARY_TYPE=$(FLOAT128) MEGAFLAGS="-DMEASURE_TYPE=${MEASURE128BIT}" -f ${SELF}

megarow:
	$(MAKE) BINARY_TYPE=$(MEGAROW) MEGAFLAGS="-DREST_EXPONENT=${MASSIVE_REST_EXP} -DID_EXPONENT=${MASSIVE_ID_EXP} -DCHROM_EXPONENT=${MASSIVE_CHROM_EXP}" -f ${SELF}

typical:
	$(MAKE) BINARY_TYPE=$(TYPICAL) -f ${SELF}

symlink_post_install_all:
	cd ${BINDIR} && ./switch-BEDOPS-binary-type --typical . && cd ${CWD}

symlink_typical:
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(TYPICAL)' -print0 | xargs -L1 -0 -I{} sh -c 'basename {}'`)
	for SRCNAME in ${SRCNAMES}; do \
		DESTNAME=`echo $$SRCNAME | sed 's/-$(TYPICAL)//'`; \
		ln -sf $$SRCNAME $(BINDIR)/$${DESTNAME}; \
	done

symlink_megarow:
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(MEGAROW)' -print0 | xargs -L1 -0 -I{} sh -c 'basename {}'`)
	for SRCNAME in ${SRCNAMES}; do \
		DESTNAME=`echo $$SRCNAME | sed 's/-$(MEGAROW)//'`; \
		ln -sf $$SRCNAME $(BINDIR)/$${DESTNAME}; \
	done

symlink_float128:
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(FLOAT128)' -print0 | xargs -L1 -0 -I{} sh -c 'basename {}'`)
	for SRCNAME in ${SRCNAMES}; do \
		DESTNAME=`echo $$SRCNAME | sed 's/-$(FLOAT128)//'`; \
		ln -sf $$SRCNAME $(BINDIR)/$${DESTNAME}; \
	done

install: prep_c install_conversion_scripts install_starch_scripts
	-cp ${APPDIR}/sort-bed/bin/sort-bed-${TYPICAL} ${BINDIR}/sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-${TYPICAL} ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-${TYPICAL} ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-${TYPICAL} ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/bedops-${TYPICAL} ${BINDIR}/bedops
	-cp ${APPDIR}/closestfeats/bin/closest-features-${TYPICAL} ${BINDIR}/closest-features
	-cp ${APPDIR}/bedmap/bin/bedmap-${TYPICAL} ${BINDIR}/bedmap
	-cp ${APPDIR}/bedextract/bin/bedextract-${TYPICAL} ${BINDIR}/bedextract
	-cp ${APPDIR}/starch/bin/starch-${TYPICAL} ${BINDIR}/starch
	-cp ${APPDIR}/starch/bin/unstarch-${TYPICAL} ${BINDIR}/unstarch
	-cp ${APPDIR}/starch/bin/starchcat-${TYPICAL} ${BINDIR}/starchcat
	-cp ${APPDIR}/starch/bin/starchstrip-${TYPICAL} ${BINDIR}/starchstrip
	-cp ${APPDIR}/conversion/bin/convert2bed-${TYPICAL} ${BINDIR}/convert2bed

install_float128: prep_c install_conversion_scripts
	-cp ${APPDIR}/sort-bed/bin/sort-bed-${FLOAT128} ${BINDIR}/sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-${FLOAT128} ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-${FLOAT128} ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-${FLOAT128} ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/bedops-${FLOAT128} ${BINDIR}/bedops
	-cp ${APPDIR}/closestfeats/bin/closest-features-${FLOAT128} ${BINDIR}/closest-features
	-cp ${APPDIR}/bedmap/bin/bedmap-${FLOAT128} ${BINDIR}/bedmap
	-cp ${APPDIR}/bedextract/bin/bedextract-${FLOAT128} ${BINDIR}/bedextract
	-cp ${APPDIR}/starch/bin/starch-${FLOAT128} ${BINDIR}/starch
	-cp ${APPDIR}/starch/bin/unstarch-${FLOAT128} ${BINDIR}/unstarch
	-cp ${APPDIR}/starch/bin/starchcat-${FLOAT128} ${BINDIR}/starchcat
	-cp ${APPDIR}/starch/bin/starchstrip-${FLOAT128} ${BINDIR}/starchstrip
	-cp ${APPDIR}/conversion/bin/convert2bed-${FLOAT128} ${BINDIR}/convert2bed

install_megarow: prep_c install_conversion_scripts
	-cp ${APPDIR}/sort-bed/bin/sort-bed-${MEGAROW} ${BINDIR}/sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-${MEGAROW} ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-${MEGAROW} ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-${MEGAROW} ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/bedops-${MEGAROW} ${BINDIR}/bedops
	-cp ${APPDIR}/closestfeats/bin/closest-features-${MEGAROW} ${BINDIR}/closest-features
	-cp ${APPDIR}/bedmap/bin/bedmap-${MEGAROW} ${BINDIR}/bedmap
	-cp ${APPDIR}/bedextract/bin/bedextract-${MEGAROW} ${BINDIR}/bedextract
	-cp ${APPDIR}/starch/bin/starch-${MEGAROW} ${BINDIR}/starch
	-cp ${APPDIR}/starch/bin/unstarch-${MEGAROW} ${BINDIR}/unstarch
	-cp ${APPDIR}/starch/bin/starchcat-${MEGAROW} ${BINDIR}/starchcat
	-cp ${APPDIR}/starch/bin/starchstrip-${MEGAROW} ${BINDIR}/starchstrip
	-cp ${APPDIR}/conversion/bin/convert2bed-${MEGAROW} ${BINDIR}/convert2bed

install_all: prep_c install_conversion_scripts_all install_starch_scripts_all
	for btype in ${ALL_BINARY_TYPES}; do \
		cp ${APPDIR}/sort-bed/bin/sort-bed-$$btype ${BINDIR}/sort-bed-$$btype; \
		cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-$$btype ${BINDIR}/update-sort-bed-slurm-$$btype; \
		cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-$$btype ${BINDIR}/update-sort-bed-starch-slurm-$$btype; \
		cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-$$btype ${BINDIR}/update-sort-bed-migrate-candidates-$$btype; \
		cp ${APPDIR}/bedops/bin/bedops-$$btype ${BINDIR}/bedops-$$btype; \
		cp ${APPDIR}/closestfeats/bin/closest-features-$$btype ${BINDIR}/closest-features-$$btype; \
		cp ${APPDIR}/bedmap/bin/bedmap-$$btype ${BINDIR}/bedmap-$$btype; \
		cp ${APPDIR}/bedextract/bin/bedextract-$$btype ${BINDIR}/bedextract-$$btype; \
		cp ${APPDIR}/starch/bin/starch-$$btype ${BINDIR}/starch-$$btype; \
		cp ${APPDIR}/starch/bin/unstarch-$$btype ${BINDIR}/unstarch-$$btype; \
		cp ${APPDIR}/starch/bin/starchcat-$$btype ${BINDIR}/starchcat-$$btype; \
		cp ${APPDIR}/starch/bin/starchstrip-$$btype ${BINDIR}/starchstrip-$$btype; \
		cp ${APPDIR}/conversion/bin/convert2bed-$$btype ${BINDIR}/convert2bed-$$btype; \
	done
	-cp ${OTHERDIR}/switch-BEDOPS-binary-type ${BINDIR}

module_binaries:
	for btype in ${ALL_BINARY_TYPES}; do \
		mkdir -p ${BINDIR_MODULE}/$$btype; \
		cp ${BINDIR}/sort-bed-$$btype ${BINDIR_MODULE}/$$btype/sort-bed; \
		cp ${BINDIR}/update-sort-bed-slurm-$$btype ${BINDIR_MODULE}/$$btype/update-sort-bed-slurm; \
		cp ${BINDIR}/update-sort-bed-starch-slurm-$$btype ${BINDIR_MODULE}/$$btype/update-sort-bed-starch-slurm; \
		cp ${BINDIR}/update-sort-bed-migrate-candidates-$$btype ${BINDIR_MODULE}/$$btype/update-sort-bed-migrate-candidates; \
		cp ${BINDIR}/bedops-$$btype ${BINDIR_MODULE}/$$btype/bedops; \
		cp ${BINDIR}/closest-features-$$btype ${BINDIR_MODULE}/$$btype/closest-features; \
		cp ${BINDIR}/bedmap-$$btype ${BINDIR_MODULE}/$$btype/bedmap; \
		cp ${BINDIR}/bedextract-$$btype ${BINDIR_MODULE}/$$btype/bedextract; \
		cp ${BINDIR}/starch-$$btype ${BINDIR_MODULE}/$$btype/starch; \
		cp ${BINDIR}/unstarch-$$btype ${BINDIR_MODULE}/$$btype/unstarch; \
		cp ${BINDIR}/starchcat-$$btype ${BINDIR_MODULE}/$$btype/starchcat; \
		cp ${BINDIR}/starchstrip-$$btype ${BINDIR_MODULE}/$$btype/starchstrip; \
		cp ${BINDIR}/starch-diff-$$btype ${BINDIR_MODULE}/$$btype/starch-diff; \
		cp ${BINDIR}/convert2bed-$$btype ${BINDIR_MODULE}/$$btype/convert2bed; \
		cp ${BINDIR}/bam2bed-$$btype ${BINDIR_MODULE}/$$btype/bam2bed; \
		cp ${BINDIR}/gff2bed-$$btype ${BINDIR_MODULE}/$$btype/gff2bed; \
		cp ${BINDIR}/gtf2bed-$$btype ${BINDIR_MODULE}/$$btype/gtf2bed; \
		cp ${BINDIR}/gvf2bed-$$btype ${BINDIR_MODULE}/$$btype/gvf2bed; \
		cp ${BINDIR}/psl2bed-$$btype ${BINDIR_MODULE}/$$btype/psl2bed; \
		cp ${BINDIR}/rmsk2bed-$$btype ${BINDIR_MODULE}/$$btype/rmsk2bed; \
		cp ${BINDIR}/sam2bed-$$btype ${BINDIR_MODULE}/$$btype/sam2bed; \
		cp ${BINDIR}/vcf2bed-$$btype ${BINDIR_MODULE}/$$btype/vcf2bed; \
		cp ${BINDIR}/wig2bed-$$btype ${BINDIR_MODULE}/$$btype/wig2bed; \
		cp ${BINDIR}/bam2starch-$$btype ${BINDIR_MODULE}/$$btype/bam2starch; \
		cp ${BINDIR}/gff2starch-$$btype ${BINDIR_MODULE}/$$btype/gff2starch; \
		cp ${BINDIR}/gtf2starch-$$btype ${BINDIR_MODULE}/$$btype/gtf2starch; \
		cp ${BINDIR}/gvf2starch-$$btype ${BINDIR_MODULE}/$$btype/gvf2starch; \
		cp ${BINDIR}/psl2starch-$$btype ${BINDIR_MODULE}/$$btype/psl2starch; \
		cp ${BINDIR}/rmsk2starch-$$btype ${BINDIR_MODULE}/$$btype/rmsk2starch; \
		cp ${BINDIR}/sam2starch-$$btype ${BINDIR_MODULE}/$$btype/sam2starch; \
		cp ${BINDIR}/vcf2starch-$$btype ${BINDIR_MODULE}/$$btype/vcf2starch; \
		cp ${BINDIR}/wig2starch-$$btype ${BINDIR_MODULE}/$$btype/wig2starch; \
		cp ${BINDIR}/bam2bed_sge-$$btype ${BINDIR_MODULE}/$$btype/bam2bed_sge; \
		cp ${BINDIR}/bam2bed_slurm-$$btype ${BINDIR_MODULE}/$$btype/bam2bed_slurm; \
		cp ${BINDIR}/bam2bed_gnuParallel-$$btype ${BINDIR_MODULE}/$$btype/bam2bed_gnuParallel; \
		cp ${BINDIR}/bam2starch_sge-$$btype ${BINDIR_MODULE}/$$btype/bam2starch_sge; \
		cp ${BINDIR}/bam2starch_slurm-$$btype ${BINDIR_MODULE}/$$btype/bam2starch_slurm; \
		cp ${BINDIR}/bam2starch_gnuParallel-$$btype ${BINDIR_MODULE}/$$btype/bam2starch_gnuParallel; \
		cp ${BINDIR}/starchcluster_sge-$$btype ${BINDIR_MODULE}/$$btype/starchcluster_sge; \
		cp ${BINDIR}/starchcluster_gnuParallel-$$btype ${BINDIR_MODULE}/$$btype/starchcluster_gnuParallel; \
		cp ${BINDIR}/starchcluster_slurm-$$btype ${BINDIR_MODULE}/$$btype/starchcluster_slurm; \
		cp ${BINDIR}/starch-diff-$$btype ${BINDIR_MODULE}/$$btype/starch-diff; \
	done

#######################
# install details

prep_c:
	mkdir -p ${BINDIR}

install_debug: prep_c install_conversion_scripts install_starch_scripts
	find ${APPDIR}/ -maxdepth 4 -mindepth 1 -type f -name 'debug.*${DEBUG_TYPE}' -exec cp {} ${BINDIR} \;

install_gprof: prep_c install_conversion_scripts install_starch_scripts
	-cp ${APPDIR}/sort-bed/bin/gprof.sort-bed ${BINDIR}/gprof.sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/gprof.bedops ${BINDIR}/gprof.bedops
	-cp ${APPDIR}/closestfeats/bin/gprof.closest-features ${BINDIR}/gprof.closest-features
	-cp ${APPDIR}/bedmap/bin/gprof.bedmap ${BINDIR}/gprof.bedmap
	-cp ${APPDIR}/bedextract/bin/gprof.bedextract ${BINDIR}/gprof.bedextract
	-cp ${APPDIR}/starch/bin/gprof.starch ${BINDIR}/gprof.starch
	-cp ${APPDIR}/starch/bin/gprof.unstarch ${BINDIR}/gprof.unstarch
	-cp ${APPDIR}/starch/bin/gprof.starchcat ${BINDIR}/gprof.starchcat

=== applications/bed/bedops/src/Makefile ===
MAIN                = ../../../..
HEAD                = $(MAIN)/interfaces/general-headers
LIB1                = $(MAIN)/interfaces/src/data/measurement
LIB2                = $(MAIN)/interfaces/src/utility
LIB3                = $(MAIN)/interfaces/src/data/starch
TESTDIR             = ../test
TMPTESTDIR          = $(TESTDIR)/regression.tests
THISDIR             = ${shell pwd}
PARTY3              = ${THISDIR}/$(MAIN)/third-party
LIBJANSSON          = libjansson.a
LIBBZIP2            = libbz2.a
LIBZLIB             = libz.a
LOCALJANSSONDIR     = ${PARTY3}/jansson
LOCALJANSSONLIBDIR  = ${LOCALJANSSONDIR}/lib
LOCALJANSSONINCDIR  = ${LOCALJANSSONDIR}/include
LOCALJANSSONLIB     = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALBZIP2DIR       = ${PARTY3}/bzip2
LOCALBZIP2LIBDIR    = ${LOCALBZIP2DIR}
LOCALBZIP2LIB       = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR    = ${LOCALBZIP2DIR}
LOCALZLIBDIR        = ${PARTY3}/zlib
LOCALZLIBLIB        = ${LOCALZLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR     = ${LOCALZLIBDIR}
OBJDIR              = objects_${BINARY_TYPE}
INCLUDES            = -iquote$(HEAD) -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBLOCATION         = -L${LOCALJANSSONLIBDIR} -L${LOCALBZIP2LIBDIR} -L${LOCALZLIBDIR}
LIBRARIES           = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
BLDFLAGS            = -Wall -pedantic -O3 -std=c++11
SFLAGS              = -static

dependency_names    = NaN starchConstants starchFileHelpers starchHelpers starchMetadataHelpers unstarchHelpers starchSha1Digest starchBase64Coding
dependencies        = $(addprefix $(OBJDIR)/, $(addsuffix .o, $(dependency_names)))
FLAGS               = $(SFLAGS) ${MEGAFLAGS} -s $(BLDFLAGS) $(dependencies) ${LIBLOCATION} ${INCLUDES}
DFLAGS              = $(SFLAGS) ${MEGAFLAGS} -g -O0 -DDEBUG_VERBOSE=1 -std=c++11 -Wall -fno-inline -pedantic -DDEBUG=1 $(dependencies) ${LIBLOCATION} ${INCLUDES}
GPROFFLAGS          = $(SFLAGS) ${MEGAFLAGS} -O -std=c++11 -Wall -pedantic -pg $(dependencies) ${LIBLOCATION} ${INCLUDES}
SOURCE1             = Bedops.cpp
BINDIR              = ../bin
PROG                = bedops-${BINARY_TYPE}

build: $(BINDIR)/$(PROG)
	rm -rf $(OBJDIR)

build_gprof: $(BINDIR)/gprof.$(PROG)
	rm -rf $(OBJDIR)

build_debug: $(BINDIR)/debug.$(PROG)
	rm -rf $(OBJDIR)

dependencies: $(dependencies)

$(BINDIR)/$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(FLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/gprof.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(GPROFFLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/debug.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(DFLAGS) ${LIBRARIES} $(SOURCE1)

$(OBJDIR)/%.o : $(LIB1)/%.cpp
	mkdir -p $(OBJDIR) && $(CXX) -c $(BLDFLAGS) $^ -o $@ ${INCLUDES}

$(OBJDIR)/%.o : $(LIB3)/%.c
	mkdir -p $(OBJDIR) && $(CXX) -c ${BLDFLAGS} $^ -o $@ ${INCLUDES}

test:
	mkdir -p $(TMPTESTDIR)
	cp $(TESTDIR)/TestPlan.xml $(TESTDIR)/Regression.java $(TMPTESTDIR)/
	cd $(TMPTESTDIR)/ && javac Regression.java
	printf "\n\nTo run regression tests:\n  cd $(TMPTESTDIR) && java Regression TestPlan.xml\n"

clean:
	rm -rf $(OBJDIR)
	rm -rf $(BINDIR)

clean_test:
	rm -rf $(TMPTESTDIR)

=== applications/bed/closestfeats/src/Makefile ===
MAIN                = ../../../..
HEAD                = $(MAIN)/interfaces/general-headers
LIB1                = $(MAIN)/interfaces/src/data/measurement
LIB2                = $(MAIN)/interfaces/src/utility
LIB3                = $(MAIN)/interfaces/src/data/starch
THISDIR             = ${shell pwd}
PARTY3              = ${THISDIR}/$(MAIN)/third-party
LIBJANSSON          = libjansson.a
LIBBZIP2            = libbz2.a
LIBZLIB             = libz.a
LOCALJANSSONDIR     = ${PARTY3}/jansson
LOCALJANSSONLIBDIR  = ${LOCALJANSSONDIR}/lib
LOCALJANSSONINCDIR  = ${LOCALJANSSONDIR}/include
LOCALJANSSONLIB     = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALBZIP2DIR       = ${PARTY3}/bzip2
LOCALBZIP2LIBDIR    = ${LOCALBZIP2DIR}
LOCALBZIP2LIB       = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR    = ${LOCALBZIP2DIR}
LOCALZLIBDIR        = ${PARTY3}/zlib
LOCALZLIBLIB        = ${LOCALZLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR     = ${LOCALZLIBDIR}
OBJDIR              = objects_${BINARY_TYPE}
INCLUDES            = -iquote$(HEAD) -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBLOCATION         = -L${LOCALJANSSONLIBDIR} -L${LOCALBZIP2LIBDIR} -L${LOCALZLIBDIR}
LIBRARIES           = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
BLDFLAGS            = -Wall -pedantic -O3 -std=c++11
SFLAGS              = -static

dependency_names    = NaN starchConstants starchFileHelpers starchHelpers starchMetadataHelpers unstarchHelpers starchSha1Digest starchBase64Coding
dependencies        = $(addprefix $(OBJDIR)/, $(addsuffix .o, $(dependency_names)))
FLAGS               = $(SFLAGS) ${MEGAFLAGS} -s $(BLDFLAGS) $(dependencies) ${LIBLOCATION} ${INCLUDES}
DFLAGS              = $(SFLAGS) ${MEGAFLAGS} -g -O0 -std=c++11 -Wall -fno-inline -pedantic $(dependencies) ${LIBLOCATION} ${INCLUDES}
GPROFFLAGS          = $(SFLAGS) ${MEGAFLAGS} -O -std=c++11 -Wall -pedantic -pg $(dependencies) ${LIBLOCATION} ${INCLUDES}
SOURCE1             = ClosestFeature.cpp
BINDIR              = ../bin
PROG                = closest-features-${BINARY_TYPE}

build: $(BINDIR)/$(PROG)
	rm -rf $(OBJDIR)

build_gprof: $(BINDIR)/gprof.$(PROG)
	rm -rf $(OBJDIR)

build_debug: $(BINDIR)/debug.$(PROG)
	rm -rf $(OBJDIR)

dependencies: $(dependencies)

$(BINDIR)/$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(FLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/gprof.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(GPROFFLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/debug.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(DFLAGS) ${LIBRARIES} $(SOURCE1)

$(OBJDIR)/%.o : $(LIB1)/%.cpp
	mkdir -p $(OBJDIR) && $(CXX) -c $(BLDFLAGS) $^ -o $@ ${INCLUDES}

$(OBJDIR)/%.o : $(LIB3)/%.c
	mkdir -p $(OBJDIR) && $(CXX) -c ${BLDFLAGS} $^ -o $@ ${INCLUDES}

clean:
	rm -rf $(OBJDIR)
	rm -rf $(BINDIR)

=== applications/bed/conversion/src/Makefile ===
BLDFLAGS                  = -Wall -Wextra -pedantic -std=c99
COMMONFLAGS               = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1
CFLAGS                    = -O3
CDFLAGS                   = -DDEBUG=1 -g -O0 -fno-inline
CPFLAGS                   = -pg
LIBS                      = -lpthread
MAIN                      = ../../../..
INTERFACES                = $(MAIN)/interfaces
HEAD                      = ${INTERFACES}/general-headers
INCLUDES                 := -iquote"${CURDIR}" -iquote"${HEAD}"
DISTDIR                   = ../bin
OBJDIR                    = objects${POSTFIX}
WRAPPERDIR                = wrappers
PROG                      = convert2bed
SOURCE                    = convert2bed.c
SFLAGS                    = -static

all: build

.PHONY: build build_debug build_gprof clean

build: $(DISTDIR)/$(PROG)-${BINARY_TYPE}
	rm -rf $(OBJDIR)
build_debug: $(DISTDIR)/debug.$(PROG)-${BINARY_TYPE}
	rm -rf $(OBJDIR)
build_gprof: $(DISTDIR)/gprof.$(PROG)-${BINARY_TYPE}
	rm -rf $(OBJDIR)

$(DISTDIR)/$(PROG)-${BINARY_TYPE}: $(PROG).c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/%-${BINARY_TYPE}: %.c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/debug.$(PROG): $(PROG).c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CDFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/debug.%-${BINARY_TYPE}: %.c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CDFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/gprof.$(PROG): $(PROG).c gprof-helper.so
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CPFLAGS) $(SFLAGS) $(INCLUDES) $< -o $@ $(LIBS)
	@echo -e "\nNote: To profile convert2bed with gprof/pthreads, run:\n\t$$ LD_PRELOAD=/path/to/gprof-helper.so convert2bed"

$(DISTDIR)/gprof.%-${BINARY_TYPE}: %.c gprof-helper.so
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CPFLAGS) $(SFLAGS) $(INCLUDES) $< -o $@ $(LIBS)
	@echo -e "\nNote: To profile convert2bed with gprof/pthreads, run:\n\t$$ LD_PRELOAD=/path/to/gprof-helper.so convert2bed"

%.so: %.c
	$(CC) -shared -fPIC $^ -o $@ $(LIBS) -ldl

clean:
	rm -rf $(DISTDIR)
	rm -rf $(OBJDIR)
	rm -rf  *.so *~

=== applications/bed/starch/src/Makefile ===
HEAD                      = ../../../..
INTERFACES                = $(HEAD)/interfaces
MAIN                      = ${INTERFACES}/general-headers
MAINAPPDIR                = ../..
PARTY3                    = $(HEAD)/third-party
BINDIR                    = ../bin
THISDIR                   = ${shell pwd}
LIBSTARCH                 = libstarch${POSTFIX}.a
LIBSTARCHDEBUG            = libstarch_debug${POSTFIX}.a
LIBSTARCHGPROF            = libstarch_gprof${POSTFIX}.a
LIBJANSSON                = libjansson.a
LIBBZIP2                  = libbz2.a
LIBZLIB                   = libz.a
LOCALSTARCHLIBDIR         = ../lib
LOCALSTARCHLIB            = ${LOCALSTARCHLIBDIR}/${LIBSTARCH}
LOCALSTARCHLIBDEBUG       = ${LOCALSTARCHLIBDIR}/${LIBSTARCHDEBUG}
LOCALSTARCHLIBGPROF       = ${LOCALSTARCHLIBDIR}/${LIBSTARCHGPROF}
LOCALJANSSONDIR           = ${THISDIR}/${PARTY3}/jansson
LOCALJANSSONLIBDIR        = ${LOCALJANSSONDIR}/lib
LOCALJANSSONLIB           = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALJANSSONINCDIR        = ${LOCALJANSSONDIR}/include
LOCALBZIP2DIR             = ${THISDIR}/${PARTY3}/bzip2
LOCALBZIP2LIBDIR          = ${LOCALBZIP2DIR}
LOCALBZIP2LIB             = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR          = ${LOCALBZIP2DIR}
LOCALZLIBDIR              = ${THISDIR}/${PARTY3}/zlib
LOCALZLIBLIBDIR           = ${LOCALZLIBDIR}
LOCALZLIBLIB              = ${LOCALZLIBLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR           = ${LOCALZLIBDIR}
OBJDIR                    = ${INTERFACES}/src/data/starch
LOCALOBJDIR               = objects${POSTFIX}
INCLUDES                  = -iquote${MAIN} -iquote${HEAD} -iquote${PARTY3} -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBRARIES                 = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
ARCH_VERSION              = v2.2
BIN_VERSION               = v2.4.27
TEST                      = ../test
TEST_LINUX_BINDIR         = ${TEST}/binaries/linux/${ARCH_VERSION}/bin
TEST_OSX_BINDIR           = ${TEST}/binaries/osx/${ARCH_VERSION}/bin
AR                        = ar
SFLAGS                    = -static
CXXFLAGS                  = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1 -DUSE_ZLIB -DUSE_BZLIB -O2 -Wformat -Wall -Wextra -Wswitch-enum -std=c++11 ${SFLAGS} -s
CXXDFLAGS                 = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1 -DUSE_ZLIB -DUSE_BZLIB -O0 -g -Wformat -Wall -Wextra -Wswitch-enum -std=c++11 -DDEBUG_VERBOSE=1 ${SFLAGS} -DDEBUG=1
CXXGFLAGS                 = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1 -DUSE_ZLIB -DUSE_BZLIB -O -Wformat -Wall -Wextra -Wswitch-enum -std=c++11 -DDEBUG_VERBOSE=1 ${SFLAGS} -DDEBUG=1 -pg

STARCH_NAMES              = starchConstants unstarchHelpers starchHelpers starchMetadataHelpers starchFileHelpers starchSha1Digest starchBase64Coding
STARCH_OBJECTS            = $(addprefix $(LOCALOBJDIR)/, $(addsuffix .o, $(STARCH_NAMES)))

.PHONY: starchcluster starch unstarch starchcat build build_debug build_gprof starch-diff starchstrip

build: starch unstarch starchcat starchcluster starch-diff starchstrip
	rm -rf ${LOCALOBJDIR}
build_debug: $(BINDIR)/debug.starch $(BINDIR)/debug.unstarch $(BINDIR)/debug.starchcat $(BINDIR)/debug.starchstrip starchcluster starch-diff
	rm -rf ${LOCALOBJDIR}
build_gprof: $(BINDIR)/gprof.starch $(BINDIR)/gprof.unstarch $(BINDIR)/gprof.starchcat $(BINDIR)/gprof.starchstrip starchcluster starch-diff
	rm -rf ${LOCALOBJDIR}

# Cancel implicit compilation rules
% : %.o
% : %.c

starch: $(BINDIR)/starch-$(BINARY_TYPE)
unstarch: $(BINDIR)/unstarch-$(BINARY_TYPE)
starchcat: $(BINDIR)/starchcat-$(BINARY_TYPE)
starchcluster: $(BINDIR)/starchcluster_gnuParallel-$(BINARY_TYPE) $(BINDIR)/starchcluster_sge-$(BINARY_TYPE) $(BINDIR)/starchcluster_slurm-$(BINARY_TYPE)
starch-diff: $(BINDIR)/starch-diff-$(BINARY_TYPE)
starchstrip: $(BINDIR)/starchstrip-$(BINARY_TYPE)

$(BINDIR)/%-$(BINARY_TYPE) : %.c $(LOCALSTARCHLIB) $(LIBRARIES)
	mkdir -p $(BINDIR)
	${CXX} ${CXXFLAGS} ${MEGAFLAGS} -c $*.c -o $(LOCALOBJDIR)/$*.o ${INCLUDES}
	${CXX} ${CXXFLAGS} ${MEGAFLAGS} $(LOCALOBJDIR)/$*.o -o $@ ${LOCALSTARCHLIB} ${LIBRARIES}

$(BINDIR)/debug.% : %.c $(LOCALSTARCHLIB) $(LIBRARIES)
	mkdir -p $(BINDIR)
	${CXX} ${CXXDFLAGS} ${MEGAFLAGS} -c $*.c -o $(LOCALOBJDIR)/$*.o ${INCLUDES}
	${CXX} ${CXXDFLAGS} ${MEGAFLAGS} $(LOCALOBJDIR)/$*.o -o $@-$(BINARY_TYPE) ${LOCALSTARCHLIB} ${LIBRARIES}

$(BINDIR)/gprof.% : %.c $(LOCALSTARCHLIB) $(LIBRARIES)
	mkdir -p $(BINDIR)
	${CXX} ${CXXGFLAGS} ${MEGAFLAGS} -c $*.c -o $(LOCALOBJDIR)/$*.o ${INCLUDES}
	${CXX} ${CXXGFLAGS} ${MEGAFLAGS} $(LOCALOBJDIR)/$*.o -o $@ ${LOCALSTARCHLIB} ${LIBRARIES}

$(BINDIR)/% : %.tcsh
	mkdir -p $(BINDIR)
	cp $< $@

$(BINDIR)/%-$(BINARY_TYPE) : %.tcsh
	mkdir -p $(BINDIR)
	cp $< $@

$(BINDIR)/% : %.py
	mkdir -p $(BINDIR)
	cp $< $@

$(BINDIR)/%-$(BINARY_TYPE) : %.py
	mkdir -p $(BINDIR)
	cp $< $@

starchLibrary: $(LOCALSTARCHLIB)

$(LOCALSTARCHLIB) : $(STARCH_OBJECTS)
	mkdir -p $(LOCALSTARCHLIBDIR)
	${AR} rcs $@ $^

$(LOCALOBJDIR)/%.o : $(OBJDIR)/%.c $(LIBRARIES)
	mkdir -p $(LOCALOBJDIR)
	${CXX} ${CXXFLAGS} ${MEGAFLAGS} -c $< -o $@ ${INCLUDES}

test: starch unstarch starchcat
	cp ${BINDIR}/starch-${BINARY_TYPE} ${TEST_LINUX_BINDIR}/starch-${BINARY_TYPE}
	cp ${BINDIR}/unstarch-${BINARY_TYPE} ${TEST_LINUX_BINDIR}/unstarch-${BINARY_TYPE}
	cp ${BINDIR}/starchcat-${BINARY_TYPE} ${TEST_LINUX_BINDIR}/starchcat-${BINARY_TYPE}
	make -C ${TEST} all

clean:
	rm -rf $(LOCALSTARCHLIBDIR)
	rm -f ${LOCALSTARCHLIBDEBUG}
	rm -f ${LOCALSTARCHLIBGPROF}
	rm -rf ${LOCALOBJDIR}
	rm -rf ${BINDIR}

=== debian/changelog ===
bedops (2.4.39+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Add parallel.patch: toplevel Makefile should use our -jN argument.
  * Update hardening.patch: our optimization flags now override upstream -O3.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Fri, 19 Feb 2021 11:50:32 +0200

bedops (2.4.39+dfsg1-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Team upload.
  * Demote documentation deps to B-D-I. (Closes: #982965)

  [ Andreas Tille ]
  * Drop binaries from source tarball
  * Do not change interpreter path for tcsh any more

 -- Andreas Tille <tille@debian.org>  Thu, 18 Feb 2021 22:23:48 +0100

=== debian/control ===
Source: bedops
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               help2man,
               libbz2-dev,
               libjansson-dev,
               python3-distutils,
               zlib1g-dev
Build-Depends-Indep: sphinx-common,
                     libjs-mathjax,
                     python3-sphinx,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/bedops
Vcs-Git: https://salsa.debian.org/med-team/bedops.git
Homepage: https://github.com/bedops/bedops

Package: bedops
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3,
         tcsh
Description: high-performance genomic feature operations
 BEDOPS is a suite of tools to address common questions raised in genomic
 studies, mostly with regard to overlap and proximity relationships between
 data sets.
 It aims to be scalable and flexible, facilitating the efficient and accurate
 analysis and management of large-scale genomic data.

Package: bedops-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-sphinxdoc,
         libjs-mathjax
Description: high-performance genomic feature operations (documentation)
 BEDOPS is a suite of tools to address common questions raised in genomic
 studies, mostly with regard to overlap and proximity relationships between
 data sets.
 It aims to be scalable and flexible, facilitating the efficient and accurate
 analysis and management of large-scale genomic data.
 .
 This package contains the BEDOPS documentation.

## bedops 2.4.40+dfsg

=== docs/requirements.txt ===
sphinx-better-theme==0.1.4

=== tests/conversion/Makefile ===
APPGROUP = conversion
CWD := $(abspath $(patsubst %/,%,$(dir $(abspath $(lastword $(MAKEFILE_LIST))))))
CONVERT2BED = $(CWD)/../../bin/convert2bed
CONVERT2BEDBIN = convert2bed
TMP := $(shell mktemp -d)
DATA = $(CWD)/data
SHELL := /bin/bash

all: 
	@echo "Testing binary group [$(APPGROUP)] and build type [$(BUILDTYPE)]"
	@$(MAKE) tests

tests: wig2bed
	@echo "Removing [$(TMP)]"
	@rm -rf $(TMP)

wig2bed: wig2bed_prep wig2bed_with_chr_prefix_no_header wig2bed_no_chr_prefix_no_header wig2bed_fixedStep_with_chr_prefix_no_header wig2bed_fixedStep_no_chr_prefix_no_header wig2bed_variableStep_with_chr_prefix_no_header wig2bed_variableStep_no_chr_prefix_no_header wig2bed_multipleTracks_with_chr_prefix_with_header wig2bed_multipleTracks_no_chr_prefix_with_header

wig2bed_prep:
	@[ -f $(CONVERT2BED) ] || echo "Missing binary [$(CONVERT2BED)] for build type [$(BUILDTYPE)]"
	@echo "Writing to [$(TMP)]"
	$(CONVERT2BED) --input=wig --version

wig2bed_with_chr_prefix_no_header:
#	Test 001
#	convert2bed --input=wig < tests/conversion/data/001.wig2bed_with_chr_prefix_no_header.001.wig > tests/conversion/data/001.wig2bed_with_chr_prefix_no_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 001]"
	@$(CONVERT2BED) --input=wig < $(DATA)/001.wig2bed_with_chr_prefix_no_header.001.wig > $(TMP)/001.wig2bed_with_chr_prefix_no_header.001.observed
	@diff $(TMP)/001.wig2bed_with_chr_prefix_no_header.001.observed $(DATA)/001.wig2bed_with_chr_prefix_no_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_no_chr_prefix_no_header:
#	Test 002
#	convert2bed --input=wig < tests/conversion/data/002.wig2bed_no_chr_prefix_no_header.001.wig > tests/conversion/data/002.wig2bed_no_chr_prefix_no_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 002]"
	@$(CONVERT2BED) --input=wig < $(DATA)/002.wig2bed_no_chr_prefix_no_header.001.wig > $(TMP)/002.wig2bed_no_chr_prefix_no_header.001.observed
	@diff $(TMP)/002.wig2bed_no_chr_prefix_no_header.001.observed $(DATA)/002.wig2bed_no_chr_prefix_no_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_fixedStep_with_chr_prefix_no_header:
#	Test 003
#	convert2bed --input=wig < tests/conversion/data/003.wig2bed_fixedStep_with_chr_prefix_no_header.001.wig > tests/conversion/data/003.wig2bed_fixedStep_with_chr_prefix_no_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 003 - step = 100, span = 1 (default)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/003.wig2bed_fixedStep_with_chr_prefix_no_header.001.wig > $(TMP)/003.wig2bed_fixedStep_with_chr_prefix_no_header.001.observed
	@diff $(TMP)/003.wig2bed_fixedStep_with_chr_prefix_no_header.001.observed $(DATA)/003.wig2bed_fixedStep_with_chr_prefix_no_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 003 - step = 100, span = 5 (custom)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/003.wig2bed_fixedStep_with_chr_prefix_no_header.002.wig > $(TMP)/003.wig2bed_fixedStep_with_chr_prefix_no_header.002.observed
	@diff $(TMP)/003.wig2bed_fixedStep_with_chr_prefix_no_header.002.observed $(DATA)/003.wig2bed_fixedStep_with_chr_prefix_no_header.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_fixedStep_no_chr_prefix_no_header:
#	Test 004
#	convert2bed --input=wig < tests/conversion/data/004.wig2bed_fixedStep_no_chr_prefix_no_header.001.wig > tests/conversion/data/004.wig2bed_fixedStep_no_chr_prefix_no_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 004 - step = 100, span = 1 (default)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/004.wig2bed_fixedStep_no_chr_prefix_no_header.001.wig > $(TMP)/004.wig2bed_fixedStep_no_chr_prefix_no_header.001.observed
	@diff $(TMP)/004.wig2bed_fixedStep_no_chr_prefix_no_header.001.observed $(DATA)/004.wig2bed_fixedStep_no_chr_prefix_no_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 004 - step = 100, span = 5 (custom)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/004.wig2bed_fixedStep_no_chr_prefix_no_header.002.wig > $(TMP)/004.wig2bed_fixedStep_no_chr_prefix_no_header.002.observed
	@diff $(TMP)/004.wig2bed_fixedStep_no_chr_prefix_no_header.002.observed $(DATA)/004.wig2bed_fixedStep_no_chr_prefix_no_header.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_variableStep_with_chr_prefix_no_header:
#	Test 005
#	convert2bed --input=wig < tests/conversion/data/005.wig2bed_variableStep_with_chr_prefix_no_header.001.wig > tests/conversion/data/005.wig2bed_variableStep_with_chr_prefix_no_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 005 - variable step, span = 1 (default)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/005.wig2bed_variableStep_with_chr_prefix_no_header.001.wig > $(TMP)/005.wig2bed_variableStep_with_chr_prefix_no_header.001.observed
	@diff $(TMP)/005.wig2bed_variableStep_with_chr_prefix_no_header.001.observed $(DATA)/005.wig2bed_variableStep_with_chr_prefix_no_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 005 - variable step, span = 5 (custom)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/005.wig2bed_variableStep_with_chr_prefix_no_header.002.wig > $(TMP)/005.wig2bed_variableStep_with_chr_prefix_no_header.002.observed
	@diff $(TMP)/005.wig2bed_variableStep_with_chr_prefix_no_header.002.observed $(DATA)/005.wig2bed_variableStep_with_chr_prefix_no_header.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_variableStep_no_chr_prefix_no_header:
#	Test 006
#	convert2bed --input=wig < tests/conversion/data/006.wig2bed_variableStep_no_chr_prefix_no_header.001.wig > tests/conversion/data/006.wig2bed_variableStep_no_chr_prefix_no_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 006 - variable step, span = 1 (default)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/006.wig2bed_variableStep_no_chr_prefix_no_header.001.wig > $(TMP)/006.wig2bed_variableStep_no_chr_prefix_no_header.001.observed
	@diff $(TMP)/006.wig2bed_variableStep_no_chr_prefix_no_header.001.observed $(DATA)/006.wig2bed_variableStep_no_chr_prefix_no_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 006 - variable step, span = 5 (custom)]"
	@$(CONVERT2BED) --input=wig < $(DATA)/006.wig2bed_variableStep_no_chr_prefix_no_header.002.wig > $(TMP)/006.wig2bed_variableStep_no_chr_prefix_no_header.002.observed
	@diff $(TMP)/006.wig2bed_variableStep_no_chr_prefix_no_header.002.observed $(DATA)/006.wig2bed_variableStep_no_chr_prefix_no_header.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_multipleTracks_with_chr_prefix_with_header:
#	Test 007
#   convert2bed --input=wig < tests/conversion/data/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.wig > tests/conversion/data/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 007 - multiple tracks]"
	@$(CONVERT2BED) --input=wig < $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.wig > $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.observed
	@diff $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.observed $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 007 - multiple tracks, with --multisplit <str> option]"
	@$(CONVERT2BED) --input=wig --multisplit foo < $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.wig > $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.002.observed
	@diff $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.002.observed $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 007 - multiple tracks, preserve header]"
	@$(CONVERT2BED) --input=wig --keep-header < $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.wig > $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.003.observed
	@diff $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.003.observed $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 007 - multiple tracks, with --multisplit <str> option, preserve header]"
	@$(CONVERT2BED) --input=wig --multisplit foo --keep-header < $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.001.wig > $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.004.observed
	@diff $(TMP)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.004.observed $(DATA)/007.wig2bed_multipleTracks_with_chr_prefix_with_header.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

wig2bed_multipleTracks_no_chr_prefix_with_header:
#	Test 008
#   convert2bed --input=wig < tests/conversion/data/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.wig > tests/conversion/data/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.expected
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 008 - multiple tracks, no chr prefix]"
	@$(CONVERT2BED) --input=wig < $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.wig > $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.observed
	@diff $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.observed $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 008 - multiple tracks, no chr prefix, with --multisplit <str> option]"
	@$(CONVERT2BED) --input=wig --multisplit foo < $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.wig > $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.002.observed
	@diff $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.002.observed $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 008 - multiple tracks, no chr prefix, preserve header]"
	@$(CONVERT2BED) --input=wig --keep-header < $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.wig > $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.003.observed
	@diff $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.003.observed $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
	@printf "[$(APPGROUP)-$(CONVERT2BEDBIN)-$(BUILDTYPE) | $@ ] - [Test 008 - multiple tracks, no chr prefix, with --multisplit <str> option, preserve header]"
	@$(CONVERT2BED) --input=wig --multisplit foo --keep-header < $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.001.wig > $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.004.observed
	@diff $(TMP)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.004.observed $(DATA)/008.wig2bed_multipleTracks_no_chr_prefix_with_header.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

=== applications/bed/bedmap/src/Makefile ===
MAIN                = ../../../..
HEAD                = ${MAIN}/interfaces/general-headers
LIB1                = ${MAIN}/interfaces/src/data/measurement
LIB2                = ${MAIN}/interfaces/src/utility
LIB3                = ${MAIN}/interfaces/src/data/starch
PARTY3              = ${THISDIR}/${MAIN}/third-party
THISDIR             = ${shell pwd}
LIBJANSSON          = libjansson.a
LIBBZIP2            = libbz2.a
LIBZLIB             = libz.a
LOCALJANSSONDIR     = ${PARTY3}/jansson
LOCALJANSSONLIBDIR  = ${LOCALJANSSONDIR}/lib
LOCALJANSSONINCDIR  = ${LOCALJANSSONDIR}/include
LOCALJANSSONLIB     = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALBZIP2DIR       = ${PARTY3}/bzip2
LOCALBZIP2LIBDIR    = ${LOCALBZIP2DIR}
LOCALBZIP2LIB       = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR    = ${LOCALBZIP2DIR}
LOCALZLIBDIR        = ${PARTY3}/zlib
LOCALZLIBLIB        = ${LOCALZLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR     = ${LOCALZLIBDIR}
OBJDIR              = objects_${BINARY_TYPE}
INCLUDES            = -iquote${HEAD} -I${PARTY3} -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBLOCATION         = -L${LOCALJANSSONLIBDIR} -L${LOCALBZIP2LIBDIR} -L${LOCALZLIBDIR}
LIBRARIES           = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
BLDFLAGS            = -Wall -pedantic -O3 -std=c++11 
SFLAGS              = -static

dependency_names    = NaN starchConstants starchFileHelpers starchHelpers starchMetadataHelpers unstarchHelpers starchSha1Digest starchBase64Coding
dependencies        = $(addprefix $(OBJDIR)/, $(addsuffix .o, $(dependency_names)))
FLAGS               = ${SFLAGS} ${MEGAFLAGS} -s ${BLDFLAGS} $(dependencies) ${LIBLOCATION} ${INCLUDES}
DFLAGS              = ${SFLAGS} ${MEGAFLAGS} -g -O0 -std=c++11 -DDEBUG=1 -fno-inline -Wall -pedantic $(dependencies) ${LIBLOCATION} ${INCLUDES}
GPROFFLAGS          = ${SFLAGS} ${MEGAFLAGS} -pg -O -std=c++11 -Wall -pedantic $(dependencies) ${LIBLOCATION} ${INCLUDES}

SOURCE1             = Bedmap.cpp
BINDIR              = ../bin
PROG                = bedmap-${BINARY_TYPE}

build: $(BINDIR)/$(PROG)
	rm -rf ${OBJDIR}

build_gprof: $(BINDIR)/gprof.$(PROG)
	rm -rf ${OBJDIR}

build_debug: $(BINDIR)/debug.$(PROG)
	rm -rf ${OBJDIR}

dependencies: $(dependencies)

$(BINDIR)/$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(FLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/gprof.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(GPROFFLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/debug.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(DFLAGS) ${LIBRARIES} $(SOURCE1)

$(OBJDIR)/%.o : $(LIB1)/%.cpp
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) $(BLDFLAGS) $^ -o $@ ${INCLUDES}

$(OBJDIR)/%.o : $(LIB3)/%.c
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) ${BLDFLAGS} $^ -o $@ ${INCLUDES}

clean:
	rm -rf ${OBJDIR}
	rm -rf ${BINDIR}

=== debian/changelog ===
bedops (2.4.40+dfsg-1) unstable; urgency=medium

  * Team Upload.
  [ Steffen Möller ]
  * Update metadata - indent plus ref to guix

  [ Nilesh Patra ]
  * Add patch to fix FTBFS with new sphinx (Closes: #997157)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 24 Oct 2021 13:20:15 +0530

## bedops 2.4.41%2Bdfsg

=== debian/changelog ===
bedops (2.4.41+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Mon, 18 Jul 2022 10:29:31 +0200
